# Contributing

## General House Keeping

PetaPoco's coding standards and guidelines are as follows:

- We follow the [Framework Design Guidelines], and expect code contributions to follow them as well.
- All public APIs should include XML doc comments (see [XML Documentation Comments (C# Programming Guide)]).
- All bug fixes should include accompanying unit test(s).
- All feature contributions **must** include accompanying unit test(s) and integration test(s).
- All PRs are to be made on the [development branch].

## How to Contribute to PetaPoco

There are a number of ways you can contribute to the PetaPoco project. When opening an issue, please use the search option *first* to ensure one hasn't already been filed.

- **Identifying issues** - Report them by opening an [opening an issue].
- **Identifying bugs/defects** - Report as an issue, then open a PR with a failing unit test(s) on the development branch.
- **Fixing bugs/defects** - Report as an issue, then open a PR on the development branch containing a fix, along with supporting unit test(s).
- **Implementing features** - Open an issue clearly describing your feature request or proposal, and wait for the community to agree. Feature PRs are to be made on the development branch, and must include appropriate supporting unit and/or integration test(s). If you don't get the go-ahead for a feature, please don't be offended if your PR is not accepted.

[Framework Design Guidelines]:https://msdn.microsoft.com/en-us/library/ms229042.aspx
[XML Documentation Comments (C# Programming Guide)]:https://msdn.microsoft.com/en-us/library/b2s063f7.aspx
[opening an issue]: https://github.com/CollaboratingPlatypus/PetaPoco/issues
[development branch]: https://github.com/CollaboratingPlatypus/PetaPoco/blob/development
